function handles=initialisationDAQ(handles)
% This functions initiate and sets the configuration with the DAQ.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  DAQ Opening
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

handles.DAQ.s=daq.createSession('ni');
handles.DAQ.s.IsContinuous = true;
handles.DAQ.s.IsNotifyWhenScansQueuedBelowAuto=true;
handles.DAQ.s.Rate = 100e3;

handles.DAQ.lh=addlistener(handles.DAQ.s,'DataRequired',@queueMoreData);

if handles.gui.mode == 1
    addAnalogOutputChannel(handles.DAQ.s,'Dev1','ao5','Voltage'); % Piezo Ref arm OCT
    addAnalogOutputChannel(handles.DAQ.s,'Dev1','ao6','Voltage'); % Trigger Camera OCT
    addAnalogOutputChannel(handles.DAQ.s,'Dev1','ao0','Voltage'); % Trigger camera Fluo
    addAnalogOutputChannel(handles.DAQ.s,'Dev1','ao7','Voltage'); % LED OCT - 1V = 200 mA
    addAnalogOutputChannel(handles.DAQ.s,'Dev1','ao3','Voltage'); % LED Fluo - 1V = 200 mA
elseif handles.gui.mode == 2
    addAnalogOutputChannel(handles.DAQ.s,'Dev1','ao5','Voltage'); % Piezo Ref arm OCT
    addAnalogOutputChannel(handles.DAQ.s,'Dev1','ao1','Voltage'); % Trigger Camera OCT
    addAnalogOutputChannel(handles.DAQ.s,'Dev1','ao0','Voltage'); % Trigger SDOCT
    addAnalogOutputChannel(handles.DAQ.s,'Dev1','ao2','Voltage'); % Trigger LED
elseif handles.gui.mode == 3
    addAnalogOutputChannel(handles.DAQ.s,'Dev4','ao1','Voltage'); % Piezo Ref arm OCT
    addAnalogOutputChannel(handles.DAQ.s,'Dev4','ao0','Voltage'); % Trigger Camera OCT
end
